/**
 *	CreateTorrent widget
 *	Copyright (c) 2007 Wojciech Rolecki <wojtekr@gmail.com> 
 *  All rights reserved.
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License as published by
 *	the Free Software Foundation; either version 2 of the License, or
 *	(at your option) any later version.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 *
 *	Bug fixes, suggestions and comments should be sent to:
 *	wojtekr@gmail.com
 */

function load()
{
	//__DEBUG("loading prefs");

	document.getElementById("announceUrlField").value = widget.preferenceForKey(widget.identifier + "@announceUrl") ||  "http://site.com/tracker";
	document.getElementById("portField").value = widget.preferenceForKey(widget.identifier + "@port") || "";
	document.getElementById("fnameField").value = widget.preferenceForKey(widget.identifier + "@fname") || "MyTorrent.torrent" ;
}

function savePreferences() {
	var announceUrl = document.getElementById("announceUrlField").value || "http://site.com/tracker";
	var port = document.getElementById("portField").value || null;
	var fname = document.getElementById("fnameField").value || "MyTorrent.torrent";

	//__DEBUG("saving prefs");

	widget.setPreferenceForKey(announceUrl, widget.identifier + "@announceUrl");
	widget.setPreferenceForKey(port, widget.identifier + "@port");
	widget.setPreferenceForKey(fname, widget.identifier + "@fname");
}

function remove()
{
	// removed
}



function hide()
{
	// your widget has just been hidden stop any timers to
	// prevent cpu usage
}

function show()
{
	// your widget has just been shown.  restart any timers
	// and adjust your interface as needed
}

function showBack(event)
{
	// your widget needs to show the back

	var front = document.getElementById("front");
	var back = document.getElementById("back");

	if (window.widget)
		widget.prepareForTransition("ToBack");

	front.style.display="none";
	back.style.display="block";
	
	if (window.widget)
		setTimeout('widget.performTransition();', 0);
}

function showFront(event)
{
	savePreferences();
	// your widget needs to show the front

	var front = document.getElementById("front");
	var back = document.getElementById("back");

	if (window.widget)
		widget.prepareForTransition("ToFront");

	front.style.display="block";
	back.style.display="none";
	
	if (window.widget)
		setTimeout('widget.performTransition();', 0);
}


if (window.widget)
{
	widget.onremove = remove;
	widget.onhide = hide;
	widget.onshow = show;
}


function dragdrop (event) {
	var uri = null;

	try {
		uri = event.dataTransfer.getData("text/uri-list");	// attempt to load the URL
	} 
	catch (e) {
		alert(e);
	}

	if (uri) // && configured)
	{
		var droppedfilesURI = uri.split("\n");
		for(var i = 0; i < droppedfilesURI.length; i++) {
			droppedfilesURI[i] = droppedfilesURI[i].toPosixPath();
		}
		var droppedfilesLocal = droppedfilesURI.join(" ");
		mktorrent(droppedfilesLocal);
	}
	else
	{
		window.alert("kaka");
	}
	
	event.stopPropagation();
	event.preventDefault();
}

// The dragenter, dragover, and dragleave functions are implemented but not used.  They
// can be used if you want to change the image when it enters the widget.

function dragenter (event) {
	event.stopPropagation();
	event.preventDefault();
}

function dragover (event) {
	event.stopPropagation();
	event.preventDefault();
}

function dragleave (event) {
	event.stopPropagation();
	event.preventDefault();
}

String.prototype.toPosixPath = function()
{
	var tmp = unescape(this.substr(this.indexOf("localhost") + 9));
	return tmp.replace(/ /g, "\\ ");
}

function make_url(url, port) {
 	var pfx = url.substring(0, url.indexOf("/", 7));
  var new_url = pfx + ":" + port +  url.substring(url.indexOf("/", 7));
  //__DEBUG("prefix == " + pfx);
  //__DEBUG("fixed url == " + new_url);
  return new_url;
}

function mktorrent(files) {
	var announceUrl = document.getElementById("announceUrlField").value || null;
	var port = document.getElementById("portField").value || null;
	var fname = document.getElementById("fnameField").value || "MyTorrent.torrent";
	var app = "/Library/Widgets/CreateTorrent.wdgt/aux/btmakemetafile.py";
	
	if (widget.system("/usr/bin/stat " + app, null).status != 0) {
		app = "~/Library/Widgets/CreateTorrent.wdgt/aux/btmakemetafile.py";
	}
	
	if (!port) {
		var cmd = app
			+ " " + announceUrl      
      + " " + "--target"
 			+ " " + "~/Desktop/" + fname
			+ " " + files; 
	} else {
		var cmd = app 
 			+ " " + make_url(announceUrl, port)
      + " " + "--target"
 			+ " " + "~/Desktop/" + fname
			+ " " + files
	}
  __DEBUG("launching: " + cmd);
	status = widget.system(cmd, null).status;
	__DEBUG("status code: " + status);
}


function __DEBUG(variable) {
	try {
		eval("alert('" + variable + " = ' + " + variable + ")");
	} catch(e) {
		alert(variable);
	}
}